//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
char gszComputerName[1024]={0};
bool gbPlug=false;

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   IdUDPServer1->DefaultPort=4000;
   IdUDPServer1->Active=true;
}
__fastcall TForm1::~TForm1()
{
   IdUDPServer1->Active=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
   DWORD dwBufLen=1024;
   try
   {
      GetComputerName(gszComputerName, &dwBufLen);
      try
      {
         IdUDPServer1->Broadcast((AnsiString)gszComputerName, 4000);
         int i=0;
         while(i<10)
         {
            Sleep(100);
            Application->ProcessMessages();
            i++;
         }
         if(gbPlug)
         {
            ShowMessage("Plug");
         }
      }
      catch(Exception &e)
      {
         ShowMessage("Socket Error or UnPlug");
      }
   }
   __finally
   {
      gbPlug=false;
      ZeroMemory(gszComputerName, dwBufLen);
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::IdUDPServer1UDPRead(TObject *Sender,
      TStream *AData, TIdSocketHandle *ABinding)
{
   TMemoryStream *ms=new TMemoryStream;
   ms->CopyFrom(AData, AData->Size);
   int iStrLen=lstrlen(gszComputerName);
   if(ms->Size==iStrLen)
   {
      char szComputerName[1024]={0};
      ms->Read(szComputerName, ms->Size);
      if(lstrcmp(gszComputerName, szComputerName))
      {
         gbPlug=true;
      }
   }
   delete ms;
}
//---------------------------------------------------------------------------

